#!/usr/bin/env python

"""
The base, abstract, class that defines the methods for updating
the firewall rules.
"""

__cvsversion__ = '$Id: FWRules.py,v 1.8 2007/12/06 23:32:20 jay Exp $'
__author__ = 'Jay Deiman; jay@splitstreams.com'
__copyright__ = 'Copyright 2007 Jason Deiman'
__license__ = 'GPLv3'
__all__ = ['FWRules']

import threading , utils , time

class FWRules(threading.Thread):
    """
    Base, abstract class for all firewall rules implementations.
    """
    def __init__(self , config , fwQ , logger):
        self._config = config
        self._fwQ = fwQ
        self._logger = logger
        threading.Thread.__init__(self)
        
    def run(self):
        """
        Main loop for this thread.  It basically blocks until something
        is put on the queue for it to do
        """
        while True:
            try: 
                cmd , ip = self._fwQ.get(block=False)
            except:
                pass
            else:
                if utils.DEBUG:
                    print 'Got a request from the Queue'
                if cmd == 'ban':
                    self.ban(ip)
                elif cmd == 'unban':
                    self.unban(ip)
            time.sleep(0.1)
    
    def ban(self , ip):
        raise NotImplementedError , 'You must override this method'
    
    def unban(self , ip):
        raise NotImplementedError , 'You must override this method'